## 1 Introduction

Coverage problems lie at the core of combinatorial optimization and have been extensively studied in computer science. A quintessential example of such problems is the

*maximum coverage*problem wherein we are given subsets of a universe along with an integer , and the objective is to find a size- set that maximizes the covering function . It is well-known that a natural greedy algorithm achieves an approximation ratio of for this problem (see, e.g., [16]). Furthermore, the work of Feige [12] shows that this approximation factor is tight, under the assumption that . Over the years, a large body of work has been directed towards extending these fundamental results and, more generally, coverage problems have been studied across multiple fields, such as operations research [7][15]

, and algorithmic game theory

[11].In this paper, we study the -multi-coverage (-coverage for short) problem, which is a natural generalization of the classic maximum coverage problem. Here, we are given a universe of elements and a collection of subsets . For any integer and a choice of index set , we define the -coverage of an element to be , i.e., counts—up to —how many times element is covered by the subsets indexed in . We extend this definition to that of -coverage of all the elements, .

The -multi-coverage problem is defined as follows: given a universe of elements , a collection of subsets of and an integer , find a size- subset which maximizes . For , it is easy to see that this reduces to the standard maximum coverage problem.

### 1.1 Our Results and Techniques

Our main result is a polynomial-time algorithm that achieves a tight approximation ratio for the -multi-coverage problem, with any .

Let be a positive integer. There exists a polynomial-time algorithm that takes as input an integer , a set system along with an integer and outputs a size- set (i.e., identifies subsets from ) such that

One way to interpret this approximation ratio is that , where

denotes a Poisson random variable with rate parameter

.We complement Theorem 1.1 by proving that the achieved approximation guarantee is tight, under the Unique Games Conjecture. Formally,

###### Theorem 1.2

Assuming the Unique Games Conjecture, it is NP-hard to approximate the maximum -multi-coverage problem to within a factor greater than , for any constant of .

##### The Approximation Algorithm

We first observe that for the maximum multi-coverage problem the standard greedy algorithm fails: the approximation guarantee does not improve with . As the function is a monotone, submodular function, the greedy algorithm will certainly still achieve an approximation ratio of . However, it is simple to construct instances wherein exactly this ratio is achieved. In fact, if is a collection of distinct subsets, let contain the same subsets as but each one appearing times. Then, it is easy to see that the greedy algorithm, when applied to , will simply choose times the sets chosen by the algorithm on input . So the greedy algorithm is not able to take advantage when we have .

Instead, we use another algorithmic idea, which is standard in the context of submodular function maximization. We consider the natural linear programming (LP) relaxation of the problem to obtain a fractional, optimal solution and apply pipage rounding

[1, 26, 5]. Pipage rounding is a method that maps a fractional solution into an integral one , in a way that does not decrease the expected value of the objective function; here the fractional solution is viewed as a (product) distribution over the index set .Hence, the core of the analysis of this algorithm is to compute the expected -coverage, , and relate it to the optimal value of the linear program (which, of course, upper bounds the value of an integral, optimal solution). With a careful use of convexity, one can establish that the analytic form of this expectation corresponds to the expected value of a binomial random variable truncated at .

To obtain the claimed approximation ratio (which, as mentioned above, has a Poisson interpretation), one would like to use the well-known Poisson approximation for binomial distributions. However, this convergence statement is only asymptotic and thus will lead to an error term that will depend on the size of the problem instance and on the value of

. One can alternatively try to compare the two distributions using the natural notion of stochastic domination. It turns out that indeed a binomial distribution can be stochastically dominated by a Poisson distribution, but this again cannot be used in our setting for two reasons: there is a loss in terms of the underlying parameters (and, hence, this cannot lead to a tight approximation factor) and more importantly the inequality goes in the wrong direction.

^{1}

^{1}1Here, the Poisson distribution stochastically dominates the binomial. Hence, instead of a lower bound, we obtain an upper bound.

The right tool for us turns out to be the notion of *convex order* between distributions. It expresses the property that one distribution is more “spread” than the other. While this notion has found several applications in statistics, economics, and other related fields (see [24] and references therein), to the best of our knowledge, its use in the context of analyzing approximation algorithms is novel. In particular, it leads to tight comparison inequalities between binomial and Poisson distributions, even in non-asymptotic regimes (see Lemma 2.1). Overall, using this tool we are able to obtain optimal approximation guarantees for all values of .

We also note that our algorithmic result directly generalizes to the weighted version of maximum -coverage and we can replace the constraint by a matroid constraint ; here, is any matroid that admits an efficient, optimization algorithm (equivalently, any matroid whose basis polytope admits an efficient separation oracle). To keep the exposition simple, we conform to the unweighted case and to the cardinality constraint and only discuss the generalization in Section 2.3.

##### Hardness Result

We now give a brief description of our hardness result and the techniques used to establish it. In [12], the inapproximability of the standard maximum coverage problem was shown using the tight inapproximability of the *set cover* problem, which in turn was obtained via a reduction from a variant of max-3-sat. However, in our setting, one cannot hope to show tight inapproximability for the maximum -multi-coverage problem by a similar sequence of reductions. This is because, as detailed in Section 1.2, the multi-coverage analogue of the set cover problem is as inapproximable as the usual set cover problem. Therefore, one cannot hope to directly reuse the arguments from Feige’s reduction in order to get tight inapproximability for the maximum -multi-coverage problem. We bypass this by developing a direct reduction to the maximum -multi-coverage problem without going through the set cover variant.

Our reduction is from a -ary hypergraph variant of UniqueGames [18, 19], which we call -AryUniqueGames. Here the constraints are given by -uniform hyperedges on a vertex set with a label set . A salient feature of the -AryUniqueGames, which is crucially used in our reduction, is that it involves two distinct notions of satisfied hyperedges, namely *strongly* and *weakly* satisfied hyperedges. A labeling strongly satisfies a hyperedge if all the labels project to the same alphabet, i.e., . We say a labelling weakly satisfies the hyperedge if at least two of the projected labels match, i.e., for some . The equivalent of Unique Games Conjecture for these instances is the following: It is NP-Hard to distinguish between whether (YES): most hyperedges can be strongly satisfied or (NO): even a small fraction of hyperedges cannot be weakly satisfied.

We employ the above variant of UniqueGames with a generalization of Feige’s partitioning gadget, which has been tailored to work with the -coverage objective . This gadget is essentially a collection of set families over a universe satisfying (i) Each family is a collection of sets such that each element in is covered exactly -times i.e, it has (normalized) -coverage (ii) Any choice of sets from distinct families has -coverage at most (the target approximation ratio). We combine the -AryUniqueGames instance with the partitioning gadget by associating each hyperedge constraint with a disjoint copy of the gadget. The construction of the set family in our reduction ensures that sets corresponding to strongly satisfied edges use property (i), whereas sets corresponding to not even weakly satisfied hyperedges use property (ii). Since in the YES case, most hyperedges can be strongly satisfied, we get that there exists a choice of sets for which the normalized -multi-coverage is close to . On the other hand, in the NO case, since most hyperedges are not even weakly satisfied, for any choice of sets, the normalized -multi-coverage will be at most . Combining the two cases gives us the desired inapproximability.

### 1.2 Related Covering Problems and Submodular Function Maximization

Another fundamental problem in the covering context is the *set cover* problem: given subsets of a universe , the objective is to find the set of minimal cardinality that cover all of , i.e., . This is one of the first problems for which approximation algorithms were studied: Johnson [17] showed that the natural greedy algorithm achieves an approximation ratio of and much later Feige [12], building on a long line of works, established a matching inapproximability result.

Along the lines of maximum coverage, one can also consider the -version of set cover. In this version, the goal is to find the smallest set such that (this corresponds to every element being covered at least times). Here, with , we observe an interesting dichotomy: while one achieves improved approximation guarantees for the maximum -multi-coverage, this is not the case for set -cover. In particular, set -cover is essentially as hard as to approximate as the standard set cover problem. To see this, consider the instance where is obtained from by adding copies of the whole set . Then, we have that can be -covered with sets in if and only if can be -covered with sets in .

A well-studied generalization of the set cover problem, called the set multicover problem, requires element to be covered at least times, where the demand is part of the input. The greedy algorithm was shown to also achieve approximation for this problem as well [8, 23]. Even though there has been extensive research on set multicover, its variants, and applications (see e.g., [3]), we are not aware of any previous work that considers the maximum multi-coverage problem.

The problem of maximum coverage fits within the larger framework of *submodular function maximization* [21]. In fact, the covering function is submodular in the sense that it satisfies a diminishing-returns property: for any and . Nemhauser et al. [21] showed that the greedy algorithm achieves the ratio not only for the coverage function but for any submodular function. Submodular functions are a central object of study in combinatorial optimization and appear in a wide variety of applications; we refer the reader to [20] for a textbook treatment of this topic. Here, an important thread of research is that of maximizing submodular functions that have an additional structure which render them closer to linear functions. Specifically, the notion of curvature of a function was introduced by [6]. The curvature of a monotone submodular function is a parameter such that for any and , we have . Note that if , this means that is a linear function and if , the condition is mute.

Conforti and Cornuéjols [6] have shown that when the greedy algorithm is applied to a function with curvature , the approximation guarantee is . Using a different algorithm, this was later improved by Sviridenko et al. [25] to a factor of approximately . This notion of curvature does have applications in some settings (see e.g., [25] and references therein), but the requirement is too strong and does not apply to the -coverage function . In fact, if is such that the sets for cover all the universe at least times, then adding another set will not change the function . Another way to see that this condition is not adapted to our -coverage problem is that we know that the greedy algorithm will not be able to beat the factor for any value of . We hope that this work will help in establishing a more operational way of interpolating between general submodular functions and linear functions.

### 1.3 Applications

We now briefly discuss some applications of the -coverage problem, the main message being that for most settings where coverage is used, -coverage has a very natural and meaningful interpretation as well. We leave the more detailed discussion of such applications for future work.

Our initial motivation for studying the maximum multi-coverage problem was in understanding the complexity of finding the code for which the list-decoding success probability is optimal. More precisely, consider a noisy channel with input set and output set that maps an input to with probability . To simplify the discussion, assume that for any input , the output is uniform on a set of size , i.e., if and otherwise. We would like to send a message belonging to the set using this noisy channel in such a way to maximize the probability of successfully decoding the message . It is elementary to see that this problem can be written as one of maximizing the quantity over codes of size [2]. Thus, the problem of finding the optimal code can be written as a covering problem, and handling general noisy channels corresponds to a weighted covering problem. This connection was exploited in [2] to prove tightness of the bound known as the *meta-converse* in the information theory literature [22] and to give limitations on the effect of quantum entanglement to decrease the communication errors. Suppose we now consider the list-decoding success probability, i.e., the receiver now decodes into a list of size and we deem the decoding successful if is in this list. Then the success probability can be written as: , i.e., an -coverage function. Our main result thus shows that the code with the maximum list-decoding success probability can be approximated to a factor of and it shows that the meta-converse for list-decoding is tight within the factor .

The applicability of the multi-coverage can also be observed in game-theoretic settings in which the (standard) covering function is used to represent valuations of agents; see, e.g., works on combinatorial auctions [10, 9]. As a stylized instantiation, consider a setup wherein the elements in the ground set represent types of goods and the given subsets correspond to bundles of goods (of different types). Assuming that, for each agent, goods of a single type are perfect substitutes of each other, one obtains valuations (defined over the bundles) that correspond to covering functions. In this context, the -multi-coverage formulation provides an operationally-useful generalization: additional copies (of the same type of the good) are valued, till a threshold . Indeed, our algorithmic result shows that if the diminishing-returns property does not come into effect right away, then better (compared to ) approximation guarantees can be obtained.

## 2 Approximation Algorithm for the -Multi-Coverage Problem

The algorithm we analyze is simple and composed of two steps (relax and round): First, we solve the natural linear programming relaxation (see (1)) obtaining a fractional, optimal solution , which satisfies . The second step is to use *pipage rounding* to find an *integral*vector with the property that . This is the size- set returned by the algorithm, . These two steps are detailed below.

##### Step 1. Solve the Linear Programming Relaxation:

Specifically, we consider the following linear programming relaxation of the -multi-coverage problem. Here, with the given collection of sets , the set denotes the indices of s that contain the element .

(1) |

In this linear program (LP), the number of variables is and the number of constraints is and, hence, an optimal solution can be found in polynomial time.

##### Step 2. Round the fractional, optimal solution:

We round the computed fractional solution by considering the multilinear extension of the objective, and applying pipage rounding [1, 26, 5] on it. Formally, given any function , one can define the multilinear extension by , where are independent random variables with .

For a submodular function , one can use pipage rounding to transform, in polynomial time, any fractional solution satisfying into an integral vector such that and . We apply this strategy for the -coverage function and the fractional, optimal solution of the LP relaxation (1). It is simple to check that the -coverage function is submodular. We thus get the following lower bound for the -coverage value of the set returned by the algorithm:^{2}^{2}2That is, a lower bound for the -coverage value of the size- set .

To conclude it suffices to relate to the value taken by the LP at the optimal solution . In particular, Theorem 1.1 directly follows from the following result (Theorem 2), which provides a lower bound in terms of the value achieved by the LP relaxation.

Indeed, this deterministic algorithm is quite direct: it simply solves a linear program and applies pipage rounding. We consider this as a positive aspect of the work and note that our key technical contribution lies in the underlying analysis.

Let and constitute a feasible solution of the LP relaxation (1). Then we have,

where is defined by

(2) |

In fact, as we show in Lemma 2.2 below, the inequality holds for every element . Before getting into the proof of this result, we establish some useful properties of the quantity .

### 2.1 Some Properties of the Approximation Ratio

Throughout, we will use , , and to, respectively, denote Poisson, Binomial, and Bernoulli random variables with appropriate parameters.

We have

In addition, the following inequality holds for any ,

(3) |

To see the first equality, write

(telescoping sum) |

which gives the desired expression.

The second equality is obtained by substituting the distribution function of and the third inequality follows from the tail-sum formula (applied over the random variable ).

To prove inequality (3), it suffices to apply Lemma 2.1 (stated and proved below) to the concave function with and .

The following lemma gives a relation between the binomial distribution and the Poisson distribution . It is well-known that, for a constant , converges to as grows. For the analysis of our algorithm, we in fact need a non-asymptotic relation between these two distributions ensuring that , for the function . Such a property is captured by the notion of convex order between distributions [24].

The next lemma uses this notion to prove the desired relation and, hence, highlights an interesting application of convex orders in the context of approximation algorithms. For any convex function , any integer and parameter , we have

(4) |

The notion of convex order between two distributions is defined as follows. If and are random variables, we say that iff holds for any convex function . We refer the reader to [24, Section 3.A] for more information and properties of this order. As a result, the lemma will follow once we show that

(5) |

First, we note that it suffices to prove this inequality for ; this is a direct consequence of the fact that the convex order is closed under convolution [24, Theorem 3.A.12] (i.e., it is closed under the addition of independent random variables).^{3}^{3}3Recall that if and are independent, Poisson random variables with rate parameters and , respectively, then is Poisson-distributed with parameter .

Now, using [24, Theorem 3.A.2], we have that equation (5) for is equivalent to showing that for any . To prove this, we perform a case analysis. The cases or are simple: here, we have and we always have . If , then

which concludes the proof. We also need a lemma about the convexity of the following function. The proof of this lemma is deferred to Appendix A.

###### Lemma 2.4

For any nonnegative integers and , the function

is non-increasing and convex in the interval . Note that when .

### 2.2 Proof of Theorem 2

We now state and prove the main lemma for the analysis of the algorithm. Let and constitute a feasible solution of the linear program (1). Then, we have for any :

To make the notation lighter, we write with indicators . Recall that , where denotes the indices of all the given subsets that contain the element .

The tail-sum formula gives us

Now we can apply Lemma 2.2 (stated and proved at the end of this section) and get that the expression for is minimum when for all , for some . We now assume has this form. Let be the number of elements such that . As we have in this case for , we can write

Note that, if , then we are done as . Assume now that and we write . We also write for the number of elements such that ; hence, .

Note that has a binomial distribution with parameters and . We can then write

where we implemented the change of variable . We now use Lemma 2.4 with and . Using the fact that this expression is increasing in together with the inequality (this follows from the linear program (1)), we get

From Lemma 2.4 again, we have that the function is convex in the interval . We now distinguish two cases. We start with the simple case when . Then we write and using convexity we get

which concludes the first case. If , we instead write . Applying convexity, we get

where to obtain the last inequality, we used equation (3) from Lemma 2.1. Now observe that is a decreasing function of and so we can lower bound it with the value it takes when . So it only remains to show that

Recalling that , this is equivalent to

In other words, it suffices to show that the sequence is an increasing sequence. To see this, we can take the logarithm of the ratio of the th term to the th term and get .

The following lemma used in the analysis is standard, see e.g., [13]. Let be such that with integer. We use the notation to compute probabilities where are independent Bernouilli random variables with . Then for any expression of the form , there exists a and such that for all and and . This also works for minimizing the probability. Let be such that it achieves the maximum for the quantity subject to . For the purpose of contradiction, assume and take different values in . Then let . And assign and . Then for any , we have

Consider the first term. We have and so the first term is a polynomial of degree in and symmetric under the exchange . The same holds for the other two terms. Furthermore, even if we are considering a sum of such terms, then we still get a symmetric polynomial of degree . So the minimum and the maximum are either achieved at the boundary with (or if ) or when . This contradicts the fact that maximizes .

### 2.3 Generalization to weighted cover subject to a matroid constraint

As mentioned previously, the algorithm can be easily generalized by allowing the objective function to be a weighted -coverage function and the constraint to be one that requires , for a matroid . More precisely, we are now given a collection of real weights . For an integer and a set , we define the weighted -coverage of an element to be ; here the maximization is over all distinct indices in the set . In other words, is the sum of the largest weights in the list . Then, as before, we define . The problem at hand is to maximize subject to the matroid constraint .

The algorithm has exactly the same structure as the one described at the beginning of this section. We consider the following linear program.

(6) |

Here is the matroid polytope of .
Again, once we obtain an optimal fractional solution , we use pipage rounding to obtain an integral vector , such that and (see, e.g., [26, Lemma 3.4]).^{4}^{4}4Note that, as before, the function is submodular. Thus, it only remains to relate this expectation to the objective value achieved by the linear program.

For a fixed , we can express the weighted coverage function as follows. First order the weights so that . Then, for , write for all . Note that . Thus, the following lemma is sufficient to obtain the desired result. Let . Assume that . Let be a feasible solution of the above linear program and be independent random variables with . Then, for , we have

Fixing and using the definition of , we can write

Comments

There are no comments yet.